#include <stdio.h>
#include <string.h>

#include "common.h"
#include "codec.h"

int embedpng = 0;
int allinone = 0;
char *filebase;

int main(int argc, char **argv)
{
  char *fname;

  printf("LocoTool V0.05 - Copyright (C) 2004 by Josef Drexler\n");

#ifdef USEICONV
  iso_to_utf8 = iconv_open("utf-8", "iso-8859-1");
  if (iso_to_utf8 == (iconv_t)-1)
	die("Cannot initialize conversion %s to %s: %s", "iso-8859-1", "utf-8", strerror(errno));

  utf16_to_utf8 = iconv_open("utf-8", "ucs-2");
  if (utf16_to_utf8 == (iconv_t)-1)
	die("Cannot initialize conversion %s to %s: %s", "utf-16", "utf-8", strerror(errno));
#endif

  if (argc < 2) die("Give filename as parameter");

  fname = argv[1];
  filebase = my_alloc(strlen(fname)+1, "filebase");

  strcpy(filebase, fname);
  if (strrchr(filebase, '.'))
	strrchr(filebase, '.')[0] = 0;

  if (stricmp(fname+strlen(fname)-4, ".xml") == 0) {
	encode(fname);
  } else {
	decode(fname);
  }

  free(filebase);

#ifdef USEICONV
  iconv_close(iso_to_utf8);
  iconv_close(utf16_to_utf8);
#endif

  return 0;
}
