
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "dump.h"
#include "locodef.h"
#include "xml.h"

const char *spriteflags[] = {
	"hasdata", "", "chunked",
	NULL
};


const char *vehspriteflags[] = {
	"hassprites",
	NULL
};

varinf vehsprites[] = {
	{ 0x00, 1, 1, "numdir" },
	{ 0x01, 1, 1, "" },
	{ 0x02, 1, 1, "" },
	{ 0x03, 1, 1, "" },
	{ 0x04, 1, 1, "" },
	{ 0x05, 1, 1, "" },
	{ 0x06, 1, 1, "" },
	{ 0x07, 1, 1, "flags", NULL, vehspriteflags },
	{ 0x08, 1, 1, "" },
	{ 0x09, 1, 1, "" },
	{ 0x0A, 1, 1, "" },
	{ 0x0B, 1, 1, "" },
	{ 0x0C, 1, 1, "" },
	{ 0x0D, 1, 1, "" },
	{ 0x0E, 1, 1, "spritenum" },
	{ 0x0F, 1, 3, "" },
	{ 0x12, 4, 1, "" },
	{ 0x16, 4, 1, "" },
	{ 0x1A, 4, 1, "" },
	{ -1 },
};

varinf vehunk[] = {
	{ 0x00, 1, 1, "" },
	{ 0x01, 1, 1, "" },
	{ 0x02, 1, 1, "" },
	{ 0x03, 1, 1, "" },
	{ 0x04, 1, 1, "spriteind" },
	{ 0x05, 1, 1, "" },
	{ -1 },
};

const char *vehflags[] = {
	"", "", "", "",
	"", "highspeedcurves", "rackrail", "",
	"", "anytrack", "", "",
	"dualhead", "", "refittable", "noannounce",
	NULL
};

varinf vehvars[] = {
	{ 0x000, 1, 2, "" },
	{ 0x002, 1, 1, "class" },
	{ 0x003, 1, 1, "" },
	{ 0x004, 1, 1, "" },
	{ 0x005, 1, 1, "" },
	{ 0x006, 1, 1, "nummods" },
	{ 0x007, 1, 1, "costind" },
	{ 0x008, 2, 1, "costfact" },
	{ 0x00A, 1, 1, "reliability" },
	{ 0x00B, 1, 1, "runcostind" },
	{ 0x00C, 2, 1, "runcostfact" },
	{ 0x00E, 1, 1, "" },
	{ 0x00F, 1, 1, "numcompat" },
	{ 0x010, 1,20, "" },
	{ 0x024, 0, 4, "", vehunk },
	{ 0x03C, 0, 4, "sprites", vehsprites },
	{ 0x0B4, 1,36, "" },
	{ 0x0D8, 2, 1, "power" },
	{ 0x0DA, 2, 1, "speed" },
	{ 0x0DC, 2, 1, "rackspeed" },
	{ 0x0DE, 2, 1, "weight" },
	{ 0x0E0, 2, 1, "flags", NULL, vehflags },
	{ 0x0E2, 1,44, "" },
	{ 0x10E, 1, 1, "" },
	{ 0x10F, 1, 1, "visfxtype" },
	{ 0x110, 1, 1, "" },
	{ 0x111, 1, 1, "" },
	{ 0x112, 1, 1, "wakefxtype" },
	{ 0x113, 1, 1, "" },
	{ 0x114, 2, 1, "designed" },
	{ 0x116, 2, 1, "obsolete" },
	{ 0x118, 1, 1, "" },
	{ 0x119, 1, 1, "startsndtype" },
	{ 0x11A, 1,64, "" },
	{ 0x15A, 1, 1, "numsnd" },
	{ 0x15B, 1, 3, "" },
	{ -1 },
};

varinf *objvars[0x22] = {
	NULL,	// 00
	NULL,	// 01
	NULL,	// 02
	NULL,	// 03
	NULL,	// 04
	NULL,	// 05
	NULL,	// 06
	NULL,	// 07
	NULL,	// 08
	NULL,	// 09
	NULL,	// 0A
	NULL,	// 0B
	NULL,	// 0C
	NULL,	// 0D
	NULL,	// 0E
	NULL,	// 0F
	NULL,	// 10
	NULL,	// 11
	NULL,	// 12
	NULL,	// 13
	NULL,	// 14
	NULL,	// 15
	NULL,	// 16
	vehvars,	// 17
	NULL,	// 18
	NULL,	// 19
	NULL,	// 1A
	NULL,	// 1B
	NULL,	// 1C
	NULL,	// 1D
	NULL,	// 1E
	NULL,	// 1F
	NULL,	// 20
	NULL,	// 21
};


uint32_t dumpveh(FILE *xml, uint8_t *data)
{
  int i;
  uint32_t dumped;

  dumped = dumpvars(xml, data, vehvars);
  dumped += dumplang(xml, data+dumped);
  if ((data[2] < 2) && !(getvalue(data+0xE0, 2) & 0x200))
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "tracktype", 0x11);
  for (i=0; i<data[6]; i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[6], "trackmod", 0x10);
  for (i=0; i<2; i++)
	dumped += dumpcap(xml, data+dumped, i, 2);
  if (data[0x10F])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "visualeffect", 0x03);
  if (data[0x112])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "wakeeffect", 0x3);
  if ((data[2] < 2) && (data[0xE0]&0x40))
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "rackrail", 0x10);
  for (i=0; i<data[15]; i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[15], "compatible", 0x17);
  if (data[0x119])
	dumped += dumpuseobj(xml, data+dumped, 0, 0, "startsnd", 0x01);
  for (i=0; i<(data[0x15A] & 0x7f); i++)
	dumped += dumpuseobj(xml, data+dumped, i, data[0x15A] & 0x7f, "soundeffect", 0x01);
  dumped += dumpsprites(xml, data+dumped);

  return dumped;
}

void addval(xmlinf *inf, uint8_t *val, uint32_t len)
{
  uint32_t ofs = inf->objdata_i.ent;

  checklen(&inf->objdata_i, ofs+len);
  memcpy(inf->objdata+ofs, val, len);
}

void add32(xmlinf *inf, uint32_t val)
{
  uint32_t ofs = inf->objdata_i.ent;

  checklen(&inf->objdata_i, ofs+4);
  *(uint32_t*) (inf->objdata+ofs) = val;
}

void add16(xmlinf *inf, uint16_t val)
{
  uint32_t ofs = inf->objdata_i.ent;

  checklen(&inf->objdata_i, ofs+2);
  *(uint16_t*) (inf->objdata+ofs) = val;
}

void add8(xmlinf *inf, uint8_t val)
{
  uint32_t ofs = inf->objdata_i.ent;

  checklen(&inf->objdata_i, ofs+1);
  inf->objdata[ofs] = val;
}


void addobj(xmlinf *inf, useobjid id, int num)
{
  int i;

  for (i=0; i<inf->useobj_i.ent; i++)
	if ( (inf->useobj[i]->type == id) && (inf->useobj[i]->num == num) ) {
		addval(inf, inf->useobj[i]->obj, 16);
		return;
	}

  die("Could not find object to use for %s[%d]", useobjnames[inf->useobj[i]->type], num);
}

void addsprites(xmlinf *inf)
{
  uint32_t i, size, ofs;

  add32(inf, inf->sprites_i.ent);

  size = 0;
  for (i=0; i<inf->sprites_i.ent; i++)
	size += inf->sprites[i]->spritesize;

  add32(inf, size);

  ofs = 0;
  for (i=0; i<inf->sprites_i.ent; i++) {
	spriteinf *s=inf->sprites[i];

	add32(inf, ofs);
	add16(inf, s->width);
	add16(inf, s->height);
	add16(inf, s->xofs);
	add16(inf, s->yofs);
	add32(inf, s->flags);

	ofs += inf->sprites[i]->spritesize;
  }

  for (i=0; i<inf->sprites_i.ent; i++)
	addval(inf, inf->spritedata[i], inf->sprites[i]->spritesize);
}

void parseveh(xmlinf *inf)
{
  int i;
  uint8_t zero;

  zero = 0;

  checklen(&inf->objdata_i, 0x15e);
  addval(inf, inf->descdata, inf->descdata_i.ent);
  if ((inf->objdata[2] < 2) && !(getvalue(inf->objdata+0xE0, 2) & 0x200))
	addobj(inf, ob_tracktype, 0);
  for (i=0; i<inf->objdata[6]; i++)
	addobj(inf, ob_trackmod, i);
  for (i=0; i<2; i++)
	if (inf->capsize[i])
		addval(inf, inf->caps[i], inf->caplen[i]);
	else
		addval(inf, &zero, 1);
  if (inf->objdata[0x10F])
	addobj(inf, ob_visualeffect, 0);
  if (inf->objdata[0x112])
	addobj(inf, ob_wakeeffect, 0);
  if ((inf->objdata[2] < 2) && (inf->objdata[0xE0]&0x40))
	addobj(inf, ob_rackrail, 0);
  for (i=0; i<inf->objdata[15]; i++)
	addobj(inf, ob_compatible, i);
  if (inf->objdata[0x119])
	addobj(inf, ob_startsnd, 0);
  for (i=0; i<(inf->objdata[0x15A] & 0x7f); i++)
	addobj(inf, ob_soundeffect, i);
  addsprites(inf);
}



dumpproc *dumpprocs[0x22] = {
	NULL,	// 00
	NULL,	// 01
	NULL,	// 02
	NULL,	// 03
	NULL,	// 04
	NULL,	// 05
	NULL,	// 06
	NULL,	// 07
	NULL,	// 08
	NULL,	// 09
	NULL,	// 0A
	NULL,	// 0B
	NULL,	// 0C
	NULL,	// 0D
	NULL,	// 0E
	NULL,	// 0F
	NULL,	// 10
	NULL,	// 11
	NULL,	// 12
	NULL,	// 13
	NULL,	// 14
	NULL,	// 15
	NULL,	// 16
	dumpveh,	// 17
	NULL,	// 18
	NULL,	// 19
	NULL,	// 1A
	NULL,	// 1B
	NULL,	// 1C
	NULL,	// 1D
	NULL,	// 1E
	NULL,	// 1F
	NULL,	// 20
	NULL,	// 21
};

parseproc *parseprocs[0x22] = {
	NULL,	// 00
	NULL,	// 01
	NULL,	// 02
	NULL,	// 03
	NULL,	// 04
	NULL,	// 05
	NULL,	// 06
	NULL,	// 07
	NULL,	// 08
	NULL,	// 09
	NULL,	// 0A
	NULL,	// 0B
	NULL,	// 0C
	NULL,	// 0D
	NULL,	// 0E
	NULL,	// 0F
	NULL,	// 10
	NULL,	// 11
	NULL,	// 12
	NULL,	// 13
	NULL,	// 14
	NULL,	// 15
	NULL,	// 16
	parseveh,	// 17
	NULL,	// 18
	NULL,	// 19
	NULL,	// 1A
	NULL,	// 1B
	NULL,	// 1C
	NULL,	// 1D
	NULL,	// 1E
	NULL,	// 1F
	NULL,	// 20
	NULL,	// 21
};
